/*
 * MD5MessageReader1Test.java
 * JUnit based test
 *
 * Created on 12  2005 ., 23:03
 */

package classes;

import junit.framework.*;
import java.io.*;

/**     MD5MessageReader.
 *    MD5  (RFC1321)   (  )
 *   ,      512 .
 * ,   MD5    , 
 *  16  (  4 ).    
 * getNextMessageBlock()  MD5MessageReader.    
 *    .
 *
 * @author  
 */
public class MD5MessageReaderTest extends TestCase {
    
    public MD5MessageReader md5mr = null;

    public MD5MessageReaderTest(String testName) {
        super(testName);
    }

    protected void setUp() throws java.lang.Exception {
        // 
        md5mr = new MD5MessageReader();
    }

    protected void tearDown() throws java.lang.Exception {
    }

    public static junit.framework.Test suite() {
        junit.framework.TestSuite suite = new junit.framework.TestSuite(MD5MessageReaderTest.class);
        
        return suite;
    }

    /**
     *    readMessage,  classes.MD5MessageReader1.
     *
     *        
     *  "_/test/test_files"
     */
    public void testReadMessage() {
        System.out.println("testReadMessage");

        try {
            md5mr.readMessage(new File("./test/test_files/test_0_byte.txt"));
            assertTrue(countBlocks() == 1);
            md5mr.readMessage(new File("./test/test_files/test_4_byte.txt"));
            assertTrue(countBlocks() == 1);
            md5mr.readMessage(new File("./test/test_files/test_5_byte.txt"));
            assertTrue(countBlocks() == 1);
            md5mr.readMessage(new File("./test/test_files/test_64_byte.txt"));
            assertTrue(countBlocks() == 2);
            md5mr.readMessage(new File("./test/test_files/test_288_byte.txt"));
            assertTrue(countBlocks() == 5);
        }
        catch(IOException ioe) {
            System.err.println(": " + ioe);
        }
    }

    /*    64   (16   4 )
          (     
       1  2 )*/
    private long countBlocks() {
        long counter = 0;
        int[] block;
        try {
            while((block = md5mr.getNextMessageBlock()) != null) {
                //     16
                if(block.length != 16)
                    fail(":    (" + block.length + ")");
                counter++;
            }
        }
        catch(IOException ioe) {
            System.err.println(": " + ioe);
        }
        return counter;
    }
}
